
"""
    Aignostics Platform API reference

     Pagination is done via `page` and `page_size`. Sorting via `sort` query parameter. The `sort` query parameter can be provided multiple times. The sorting direction can be indicated via `+` (ascending) or `-` (descending) (e.g. `/v1/applications?sort=+name)`.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from aignx.codegen.models.payload_item import PayloadItem
from aignx.codegen.models.payload_output_artifact import PayloadOutputArtifact
from typing import Optional, Set
from typing_extensions import Self

class UserPayload(BaseModel):
    """
    UserPayload
    """ # noqa: E501
    application_id: StrictStr
    application_run_id: StrictStr
    global_output_artifacts: Optional[Dict[str, PayloadOutputArtifact]]
    items: List[PayloadItem]
    __properties: ClassVar[List[str]] = ["application_id", "application_run_id", "global_output_artifacts", "items"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in global_output_artifacts (dict)
        _field_dict = {}
        if self.global_output_artifacts:
            for _key_global_output_artifacts in self.global_output_artifacts:
                if self.global_output_artifacts[_key_global_output_artifacts]:
                    _field_dict[_key_global_output_artifacts] = self.global_output_artifacts[_key_global_output_artifacts].to_dict()
            _dict['global_output_artifacts'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item_items in self.items:
                if _item_items:
                    _items.append(_item_items.to_dict())
            _dict['items'] = _items
        # set to None if global_output_artifacts (nullable) is None
        # and model_fields_set contains the field
        if self.global_output_artifacts is None and "global_output_artifacts" in self.model_fields_set:
            _dict['global_output_artifacts'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "application_id": obj.get("application_id"),
            "application_run_id": obj.get("application_run_id"),
            "global_output_artifacts": dict(
                (_k, PayloadOutputArtifact.from_dict(_v))
                for _k, _v in obj["global_output_artifacts"].items()
            )
            if obj.get("global_output_artifacts") is not None
            else None,
            "items": [PayloadItem.from_dict(_item) for _item in obj["items"]] if obj.get("items") is not None else None
        })
        return _obj
